Index: branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/DefineExpressions.cs
===================================================================
--- branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/DefineExpressions.cs	(revision 14397)
+++ branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/DefineExpressions.cs	(revision 14398)
@@ -10,9 +10,6 @@
     /// </summary>
     /// <typeparam name="T">Stacktype</typeparam>
-    public abstract class DefineExpression<T> : Expression
+    public abstract class DefineExpression<T> : StatelessExpression
     {
-        public DefineExpression(string stringRepresentation) : base(stringRepresentation)
-        { }
-
         protected void Eval(IStack<T> stack, IStack<string> nameStack, IDictionary<string, Expression> customExpressions, Func<T, Expression> creator)
         {
@@ -38,6 +35,7 @@
     public class CodeDefineExpression : DefineExpression<Expression>
     {
-        public CodeDefineExpression() : base("CODE.DEFINE")
+        protected override string InitStringRepresentation()
         {
+            return "CODE.DEFINE";
         }
 
@@ -48,5 +46,5 @@
                 return;
 
-            this.Eval(
+            Eval(
                 interpreter.CodeStack,
                 interpreter.NameStack,
@@ -60,6 +58,7 @@
     public class ExecDefineExpression : DefineExpression<Expression>
     {
-        public ExecDefineExpression() : base("EXEC.DEFINE")
+        protected override string InitStringRepresentation()
         {
+            return "EXEC.DEFINE";
         }
 
@@ -69,5 +68,5 @@
                 return;
 
-            this.Eval(
+            Eval(
                 interpreter.ExecStack,
                 interpreter.NameStack,
@@ -81,11 +80,12 @@
     public class FloatDefineExpression : DefineExpression<double>
     {
-        public FloatDefineExpression() : base("FLOAT.DEFINE")
+        protected override string InitStringRepresentation()
         {
+            return "FLOAT.DEFINE";
         }
 
         public override void Eval(IInterpreter interpreter)
         {
-            this.Eval(
+            Eval(
                 interpreter.FloatStack,
                 interpreter.NameStack,
@@ -97,11 +97,12 @@
     public class IntegerDefineExpression : DefineExpression<long>
     {
-        public IntegerDefineExpression() : base("INTEGER.DEFINE")
+        protected override string InitStringRepresentation()
         {
+            return "INTEGER.DEFINE";
         }
 
         public override void Eval(IInterpreter interpreter)
         {
-            this.Eval(
+            Eval(
                 interpreter.IntegerStack,
                 interpreter.NameStack,
@@ -113,11 +114,12 @@
     public class BooleanDefineExpression : DefineExpression<bool>
     {
-        public BooleanDefineExpression() : base("BOOLENA.DEFINE")
+        protected override string InitStringRepresentation()
         {
+            return "BOOLEAN.DEFINE";
         }
 
         public override void Eval(IInterpreter interpreter)
         {
-            this.Eval(
+            Eval(
                 interpreter.BooleanStack,
                 interpreter.NameStack,
Index: branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/DoCountExpressions.cs
===================================================================
--- branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/DoCountExpressions.cs	(revision 14397)
+++ branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/DoCountExpressions.cs	(revision 14398)
@@ -1,4 +1,5 @@
 ﻿using HeuristicLab.Algorithms.PushGP.Interpreter;
 using HeuristicLab.Algorithms.PushGP.Stack;
+using HeuristicLab.Common;
 
 namespace HeuristicLab.Algorithms.PushGP.Expressions
@@ -6,5 +7,9 @@
     public abstract class DoCountExpression : LoopExpression
     {
-        public DoCountExpression(string stringRepresentation) : base(stringRepresentation) { }
+        public DoCountExpression()
+        { }
+
+        public DoCountExpression(LoopExpression origin, Cloner cloner) : base(origin, cloner)
+        { }
 
         protected override bool HasInsufficientArguments(IInterpreter interpreter, IStack<Expression> sourceStack)
@@ -17,8 +22,8 @@
         protected override void InitState(IInterpreter interpreter, IStack<Expression> sourceStack)
         {
-            this.body = sourceStack.Pop();
-            this.destinationIndex = interpreter.IntegerStack.Top;
-            this.currentIndex = 1;
-            this.incrementor = 1;
+            body = sourceStack.Pop();
+            destinationIndex = interpreter.IntegerStack.Top;
+            currentIndex = 1;
+            incrementor = 1;
 
             interpreter.IntegerStack.SetTop(0);
@@ -34,12 +39,25 @@
     /// ( 0 '1 - IntegerArg>' CODE.QUOTE 'CodeArg' CODE.DO*RANGE )
     /// </summary>
-    [StatefullExpression]
     public class CodeDoCountExpression : DoCountExpression
     {
-        public CodeDoCountExpression() : base("CODE.DO*COUNT") { }
+        public CodeDoCountExpression()
+        { }
+
+        protected CodeDoCountExpression(CodeDoCountExpression origin, Cloner cloner) : base(origin, cloner)
+        { }
+
+        public override IDeepCloneable Clone(Cloner cloner)
+        {
+            return new CodeDoCountExpression(this, cloner);
+        }
+
+        protected override string InitStringRepresentation()
+        {
+            return "CODE.DO*COUNT";
+        }
 
         public override void Eval(IInterpreter interpreter)
         {
-            this.Eval(interpreter, interpreter.CodeStack);
+            Eval(interpreter, interpreter.CodeStack);
         }
     }
@@ -54,12 +72,25 @@
     /// ( 0 '1 - IntegerArg' EXEC.DO* RANGE'ExecArg' )
     /// </summary>
-    [StatefullExpression]
     public class ExecDoCountExpression : DoCountExpression
     {
-        public ExecDoCountExpression() : base("EXEC.DO*COUNT") { }
+        public ExecDoCountExpression()
+        { }
+
+        protected ExecDoCountExpression(ExecDoCountExpression origin, Cloner cloner) : base(origin, cloner)
+        { }
+
+        public override IDeepCloneable Clone(Cloner cloner)
+        {
+            return new ExecDoCountExpression(this, cloner);
+        }
+
+        protected override string InitStringRepresentation()
+        {
+            return "EXEC.DO*COUNT";
+        }
 
         public override void Eval(IInterpreter interpreter)
         {
-            this.Eval(interpreter, interpreter.ExecStack);
+            Eval(interpreter, interpreter.ExecStack);
         }
     }
Index: branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/DoRangeExpressions.cs
===================================================================
--- branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/DoRangeExpressions.cs	(revision 14397)
+++ branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/DoRangeExpressions.cs	(revision 14398)
@@ -1,4 +1,5 @@
 ﻿using HeuristicLab.Algorithms.PushGP.Interpreter;
 using HeuristicLab.Algorithms.PushGP.Stack;
+using HeuristicLab.Common;
 
 namespace HeuristicLab.Algorithms.PushGP.Expressions
@@ -6,5 +7,9 @@
     public abstract class DoRangeExpression : LoopExpression
     {
-        public DoRangeExpression(string stringRepresentation) : base(stringRepresentation) { }
+        public DoRangeExpression()
+        { }
+
+        public DoRangeExpression(LoopExpression origin, Cloner cloner) : base(origin, cloner)
+        { }
 
         protected override bool HasInsufficientArguments(IInterpreter interpreter, IStack<Expression> sourceStack)
@@ -17,9 +22,9 @@
         protected override void InitState(IInterpreter interpreter, IStack<Expression> sourceStack)
         {
-            this.body = sourceStack.Pop();
-            this.destinationIndex = interpreter.IntegerStack.Pop();
-            this.currentIndex = interpreter.IntegerStack.Top;
-            this.incrementor = this.destinationIndex < this.currentIndex ? -1 : 1;
-            this.currentIndex += this.incrementor;
+            body = sourceStack.Pop();
+            destinationIndex = interpreter.IntegerStack.Pop();
+            currentIndex = interpreter.IntegerStack.Top;
+            incrementor = destinationIndex < currentIndex ? -1 : 1;
+            currentIndex += incrementor;
         }
     }
@@ -38,12 +43,25 @@
     /// that is less than the specified current index.
     /// </summary>
-    [StatefullExpression]
     public class CodeDoRangeExpression : DoRangeExpression
     {
-        public CodeDoRangeExpression() : base("CODE.DO*RANGE") { }
+        public CodeDoRangeExpression()
+        { }
+
+        protected CodeDoRangeExpression(CodeDoRangeExpression origin, Cloner cloner) : base(origin, cloner)
+        { }
+
+        public override IDeepCloneable Clone(Cloner cloner)
+        {
+            return new CodeDoRangeExpression(this, cloner);
+        }
+
+        protected override string InitStringRepresentation()
+        {
+            return "CODE.DO*RANGE";
+        }
 
         public override void Eval(IInterpreter interpreter)
         {
-            this.Eval(interpreter, interpreter.CodeStack);
+            Eval(interpreter, interpreter.CodeStack);
         }
     }
@@ -63,12 +81,25 @@
     /// index that is less than the specified current index.
     /// </summary>
-    [StatefullExpression]
     public class ExecDoRangeExpression : DoRangeExpression
     {
-        public ExecDoRangeExpression() : base("EXEC.DO*RANGE") { }
+        public ExecDoRangeExpression()
+        { }
+
+        protected ExecDoRangeExpression(ExecDoRangeExpression origin, Cloner cloner) : base(origin, cloner)
+        { }
+
+        public override IDeepCloneable Clone(Cloner cloner)
+        {
+            return new ExecDoRangeExpression(this, cloner);
+        }
+
+        protected override string InitStringRepresentation()
+        {
+            return "EXEC.DO*RANGE";
+        }
 
         public override void Eval(IInterpreter interpreter)
         {
-            this.Eval(interpreter, interpreter.ExecStack);
+            Eval(interpreter, interpreter.ExecStack);
         }
     }
Index: branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/DoTimesExpressions.cs
===================================================================
--- branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/DoTimesExpressions.cs	(revision 14397)
+++ branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/DoTimesExpressions.cs	(revision 14398)
@@ -1,4 +1,5 @@
 ﻿using HeuristicLab.Algorithms.PushGP.Interpreter;
 using HeuristicLab.Algorithms.PushGP.Stack;
+using HeuristicLab.Common;
 
 namespace HeuristicLab.Algorithms.PushGP.Expressions
@@ -6,5 +7,9 @@
     public abstract class DoTimesExpression : LoopExpression
     {
-        public DoTimesExpression(string stringRepresentation) : base(stringRepresentation) { }
+        public DoTimesExpression()
+        { }
+
+        public DoTimesExpression(LoopExpression origin, Cloner cloner) : base(origin, cloner)
+        { }
 
         protected override bool HasInsufficientArguments(IInterpreter interpreter, IStack<Expression> sourceStack)
@@ -17,18 +22,18 @@
         protected override void InitState(IInterpreter interpreter, IStack<Expression> sourceStack)
         {
-            this.body = sourceStack.Pop();
-            this.destinationIndex = interpreter.IntegerStack.Pop();
-            this.currentIndex = 1;
-            this.incrementor = 1;
+            body = sourceStack.Pop();
+            destinationIndex = interpreter.IntegerStack.Pop();
+            currentIndex = 1;
+            incrementor = 1;
         }
 
         protected override void PushIteration(IInterpreter interpreter)
         {
-            interpreter.ExecStack.Push(this, this.body);
+            interpreter.ExecStack.Push(this, body);
         }
 
         protected override void PushLastIteration(IInterpreter interpreter)
         {
-            interpreter.ExecStack.Push(this.body);
+            interpreter.ExecStack.Push(body);
         }
     }
@@ -40,12 +45,26 @@
     /// in the call to CODE.DO*RANGE.
     /// </summary>
-    [StatefullExpression]
+
     public class CodeDoTimesExpression : DoTimesExpression
     {
-        public CodeDoTimesExpression() : base("CODE.DO*TIMES") { }
+        public CodeDoTimesExpression()
+        { }
+
+        protected CodeDoTimesExpression(CodeDoTimesExpression origin, Cloner cloner) : base(origin, cloner)
+        { }
+
+        public override IDeepCloneable Clone(Cloner cloner)
+        {
+            return new CodeDoTimesExpression(this, cloner);
+        }
+
+        protected override string InitStringRepresentation()
+        {
+            return "CODE.DO*TIMES";
+        }
 
         public override void Eval(IInterpreter interpreter)
         {
-            this.Eval(interpreter, interpreter.CodeStack);
+            Eval(interpreter, interpreter.CodeStack);
         }
     }
@@ -57,12 +76,26 @@
     /// pushed by EXEC.DO*RANGE, prior to the execution of the loop body.
     /// </summary>
-    [StatefullExpression]
+
     public class ExecDoTimesExpression : DoTimesExpression
     {
-        public ExecDoTimesExpression() : base("EXEC.DO*TIMES") { }
+        public ExecDoTimesExpression()
+        { }
+
+        protected ExecDoTimesExpression(ExecDoTimesExpression origin, Cloner cloner) : base(origin, cloner)
+        { }
+
+        public override IDeepCloneable Clone(Cloner cloner)
+        {
+            return new ExecDoTimesExpression(this, cloner);
+        }
+
+        protected override string InitStringRepresentation()
+        {
+            return "EXEC.DO*TIMES";
+        }
 
         public override void Eval(IInterpreter interpreter)
         {
-            this.Eval(interpreter, interpreter.ExecStack);
+            Eval(interpreter, interpreter.ExecStack);
         }
     }
Index: branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/DuplicateExpressions.cs
===================================================================
--- branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/DuplicateExpressions.cs	(revision 14397)
+++ branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/DuplicateExpressions.cs	(revision 14398)
@@ -9,9 +9,6 @@
     /// </summary>
     /// <typeparam name="T">Stacktype</typeparam>
-    public abstract class DuplicateExpression<T> : Expression
+    public abstract class DuplicateExpression<T> : StatelessExpression
     {
-        public DuplicateExpression(string stringRepresentation) : base(stringRepresentation)
-        { }
-
         public void Eval(IStack<T> stack)
         {
@@ -25,10 +22,9 @@
     public class IntegerDuplicateExpression : DuplicateExpression<long>
     {
-        public IntegerDuplicateExpression() : base("INTEGER.DUP")
-        { }
+        protected override string InitStringRepresentation() { return "INTEGER.DUP"; }
 
         public override void Eval(IInterpreter interpreter)
         {
-            this.Eval(interpreter.IntegerStack);
+            Eval(interpreter.IntegerStack);
         }
     }
@@ -36,10 +32,9 @@
     public class FloatDuplicateExpression : DuplicateExpression<double>
     {
-        public FloatDuplicateExpression() : base("FLOAT.DUP")
-        { }
+        protected override string InitStringRepresentation() { return "FLOAT.DUP"; }
 
         public override void Eval(IInterpreter interpreter)
         {
-            this.Eval(interpreter.FloatStack);
+            Eval(interpreter.FloatStack);
         }
     }
@@ -47,10 +42,9 @@
     public class BooleanDuplicateExpression : DuplicateExpression<bool>
     {
-        public BooleanDuplicateExpression() : base("BOOLEAN.DUP")
-        { }
+        protected override string InitStringRepresentation() { return "BOOLEAN.DUP"; }
 
         public override void Eval(IInterpreter interpreter)
         {
-            this.Eval(interpreter.BooleanStack);
+            Eval(interpreter.BooleanStack);
         }
     }
@@ -58,10 +52,9 @@
     public class NameDuplicateExpression : DuplicateExpression<string>
     {
-        public NameDuplicateExpression() : base("NAME.DUP")
-        { }
+        protected override string InitStringRepresentation() { return "NAME.DUP"; }
 
         public override void Eval(IInterpreter interpreter)
         {
-            this.Eval(interpreter.NameStack);
+            Eval(interpreter.NameStack);
         }
     }
@@ -69,10 +62,9 @@
     public class ExecDuplicateExpression : DuplicateExpression<Expression>
     {
-        public ExecDuplicateExpression() : base("EXEC.DUP")
-        { }
+        protected override string InitStringRepresentation() { return "EXEC.DUP"; }
 
         public override void Eval(IInterpreter interpreter)
         {
-            this.Eval(interpreter.ExecStack);
+            Eval(interpreter.ExecStack);
         }
     }
@@ -80,10 +72,9 @@
     public class CodeDuplicateExpression : DuplicateExpression<Expression>
     {
-        public CodeDuplicateExpression() : base("CODE.DUP")
-        { }
+        protected override string InitStringRepresentation() { return "CODE.DUP"; }
 
         public override void Eval(IInterpreter interpreter)
         {
-            this.Eval(interpreter.CodeStack);
+            Eval(interpreter.CodeStack);
         }
     }
Index: branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/ERCExpressions.cs
===================================================================
--- branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/ERCExpressions.cs	(revision 14397)
+++ branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/ERCExpressions.cs	(revision 14398)
@@ -1,5 +1,7 @@
-﻿using HeuristicLab.Algorithms.PushGP.Generators;
+﻿using System;
+using HeuristicLab.Algorithms.PushGP.Generators;
 using HeuristicLab.Algorithms.PushGP.Interpreter;
 using HeuristicLab.Algorithms.PushGP.Stack;
+using HeuristicLab.Common;
 using HeuristicLab.Core;
 using HeuristicLab.Random;
@@ -10,5 +12,6 @@
     {
         private readonly T value;
-        public ERCExpression(string stringRepresentation, T value) : base(stringRepresentation)
+
+        public ERCExpression(T value)
         {
             this.value = value;
@@ -17,5 +20,32 @@
         protected void Eval(IStack<T> stack)
         {
-            stack.Push(this.value);
+            stack.Push(value);
+        }
+
+        /// <summary>
+        /// Does not make sense
+        /// </summary>
+        /// <returns></returns>
+        protected override string InitStringRepresentation()
+        {
+            throw new NotImplementedException();
+        }
+
+        /// <summary>
+        /// Does not make sense
+        /// </summary>
+        /// <returns></returns>
+        protected override int InitId()
+        {
+            throw new NotImplementedException();
+        }
+
+        /// <summary>
+        /// Does not make sense
+        /// </summary>
+        /// <returns></returns>
+        public override IDeepCloneable Clone(Cloner cloner)
+        {
+            throw new NotImplementedException();
         }
     }
@@ -23,5 +53,5 @@
     public class IntegerERCExpression : ERCExpression<long>
     {
-        public IntegerERCExpression() : base("INTEGER.ERC", IntegerGenerator.RandomInteger())
+        public IntegerERCExpression() : base(IntegerGenerator.RandomInteger())
         {
         }
@@ -29,5 +59,5 @@
         public override void Eval(IInterpreter interpreter)
         {
-            this.Eval(interpreter.IntegerStack);
+            Eval(interpreter.IntegerStack);
         }
     }
@@ -37,5 +67,5 @@
         protected bool isInitialized = false;
 
-        public FloatERCExpression() : base("FLOAT.ERC", FloatGenerator.RandomFloat())
+        public FloatERCExpression() : base(FloatGenerator.RandomFloat())
         {
         }
@@ -43,5 +73,5 @@
         public override void Eval(IInterpreter interpreter)
         {
-            this.Eval(interpreter.FloatStack);
+            Eval(interpreter.FloatStack);
         }
     }
@@ -49,5 +79,5 @@
     public class BooleanERCExpression : ERCExpression<bool>
     {
-        public BooleanERCExpression() : base("BOOLEAN.ERC", BooleanGenerator.RandomBoolean())
+        public BooleanERCExpression() : base(BooleanGenerator.RandomBoolean())
         {
         }
@@ -55,5 +85,5 @@
         public override void Eval(IInterpreter interpreter)
         {
-            this.Eval(interpreter.BooleanStack);
+            Eval(interpreter.BooleanStack);
         }
     }
@@ -63,5 +93,5 @@
         private static IRandom random = new FastRandom();
 
-        public NameERCExpression() : base("NAME.ERC", NameGenerator.RandomName())
+        public NameERCExpression() : base(NameGenerator.RandomName())
         {
         }
@@ -69,5 +99,5 @@
         public override void Eval(IInterpreter interpreter)
         {
-            this.Eval(interpreter.NameStack);
+            Eval(interpreter.NameStack);
         }
     }
Index: branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/EqualsExpressions.cs
===================================================================
--- branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/EqualsExpressions.cs	(revision 14397)
+++ branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/EqualsExpressions.cs	(revision 14398)
@@ -8,9 +8,6 @@
     /// </summary>
     /// <typeparam name="T">Stacktype</typeparam>
-    public abstract class EqualsExpression<T> : Expression
+    public abstract class EqualsExpression<T> : StatelessExpression
     {
-        public EqualsExpression(string stringRepresentation) : base(stringRepresentation)
-        { }
-
         public void Eval(IStack<T> stack, IStack<bool> booleanStack)
         {
@@ -26,10 +23,9 @@
     public class IntegerEqualsExpression : EqualsExpression<long>
     {
-        public IntegerEqualsExpression() : base("INTEGER.=")
-        { }
+        protected override string InitStringRepresentation() { return "INTEGER.="; }
 
         public override void Eval(IInterpreter interpreter)
         {
-            this.Eval(interpreter.IntegerStack, interpreter.BooleanStack);
+            Eval(interpreter.IntegerStack, interpreter.BooleanStack);
         }
     }
@@ -37,10 +33,9 @@
     public class FloatEqualsExpression : EqualsExpression<double>
     {
-        public FloatEqualsExpression() : base("FLOAT.=")
-        { }
+        protected override string InitStringRepresentation() { return "FLOAT.="; }
 
         public override void Eval(IInterpreter interpreter)
         {
-            this.Eval(interpreter.FloatStack, interpreter.BooleanStack);
+            Eval(interpreter.FloatStack, interpreter.BooleanStack);
         }
     }
@@ -48,10 +43,9 @@
     public class BooleanEqualsExpression : EqualsExpression<bool>
     {
-        public BooleanEqualsExpression() : base("BOOLEAN.=")
-        { }
+        protected override string InitStringRepresentation() { return "BOOLEAN.="; }
 
         public override void Eval(IInterpreter interpreter)
         {
-            this.Eval(interpreter.BooleanStack, interpreter.BooleanStack);
+            Eval(interpreter.BooleanStack, interpreter.BooleanStack);
         }
     }
@@ -59,10 +53,9 @@
     public class NameEqualsExpression : EqualsExpression<string>
     {
-        public NameEqualsExpression() : base("NAME.=")
-        { }
+        protected override string InitStringRepresentation() { return "NAME.="; }
 
         public override void Eval(IInterpreter interpreter)
         {
-            this.Eval(interpreter.NameStack, interpreter.BooleanStack);
+            Eval(interpreter.NameStack, interpreter.BooleanStack);
         }
     }
@@ -70,10 +63,9 @@
     public class ExecEqualsExpression : EqualsExpression<Expression>
     {
-        public ExecEqualsExpression() : base("EXEC.=")
-        { }
+        protected override string InitStringRepresentation() { return "EXEC.="; }
 
         public override void Eval(IInterpreter interpreter)
         {
-            this.Eval(interpreter.ExecStack, interpreter.BooleanStack);
+            Eval(interpreter.ExecStack, interpreter.BooleanStack);
         }
     }
@@ -81,10 +73,9 @@
     public class CodeEqualsExpression : EqualsExpression<Expression>
     {
-        public CodeEqualsExpression() : base("CODE.=")
-        { }
+        protected override string InitStringRepresentation() { return "CODE.="; }
 
         public override void Eval(IInterpreter interpreter)
         {
-            this.Eval(interpreter.CodeStack, interpreter.BooleanStack);
+            Eval(interpreter.CodeStack, interpreter.BooleanStack);
         }
     }
